var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React, { useState, useCallback } from 'react';
import { TextArea } from '@compoz/ui';
var JsonTextArea = function (_a) {
    var value = _a.value, setValue = _a.setValue, props = __rest(_a, ["value", "setValue"]);
    var _b = useState(JSON.stringify(value, null, '    ')), rawValue = _b[0], setRawValue = _b[1];
    var _c = useState(null), error = _c[0], setError = _c[1];
    var onChange = useCallback(function (e) {
        var textarea = e.target;
        var jsonString = textarea.value;
        setRawValue(jsonString);
        console.log(jsonString);
        try {
            var json = JSON.parse(jsonString);
            setError(null);
            console.log("setValue()", json);
            setValue(json);
        }
        catch (err) {
            setError(err.message.replace(/\n/g, '\\n').replace(/\r/g, '\\r').replace(/\t/g, '\\t'));
        }
    }, [setValue, setError]);
    var style = {};
    if (error !== null) {
        style.borderColor = 'red';
    }
    return (React.createElement(React.Fragment, null,
        React.createElement(TextArea, __assign({}, props, { value: rawValue, onChange: onChange, style: style })),
        error !== null && (React.createElement("div", null, error))));
};
export default JsonTextArea;
