import { Code } from 'react-feather';
import JsonBlockRenderer from './JsonBlockRenderer';
import JsonBlockConfigurator from './JsonBlockConfigurator';
var jsonModule = {
    description: "\nAdd ability to inject static json data in context\nto be available for child blocks.\n",
    version: '0.1.3',
    schema: {
        data: {
            type: 'object'
        }
    },
    defaults: {
        label: 'Json Data',
        settings: {
            contextKey: 'jsonData',
            data: {}
        }
    },
    icon: Code,
    renderer: JsonBlockRenderer,
    configurator: JsonBlockConfigurator,
    shouldAddChild: function () { return true; },
    shouldBeAdded: function () { return true; },
};
export default jsonModule;
